Skip to main content

openmoat_proxy/
decide.rs

1//! Which hosts and addresses the proxy may reach.
2//!
3//! A host is decided exactly as `moat guard` decides a fetch tool's URL: one
4//! `fetch` atom through openmoat-core's [`CompiledPolicy`], so `fetch` and `net`
5//! lists both apply and deny rules come first. The proxy cannot prompt, so an
6//! `review` is refused. Cloud metadata and link-local addresses are refused
7//! whatever the policy says, by name and again after DNS resolution. Private
8//! and CGNAT addresses are refused unless an allow rule names the address.
9//! Every resolved address is also checked against the deny rules, so a deny
10//! naming an address holds for a name that resolves to it.
11
12mod ports;
13
14use std::net::{IpAddr, Ipv4Addr, Ipv6Addr, SocketAddr};
15
16pub use self::ports::{DEFAULT_PORTS, RULE_PORT, host_port, port_policy};
17
18use openmoat_core::{
19    Action, AtomicAction, CompiledPolicy, Decision, Defaults, Kind, MapPathResolver, Policy, Taint,
20    Verdict,
21};
22
23/// Rule id for a destination refused whatever the policy says.
24pub const RULE_ADDRESS: &str = "proxy-address";
25/// Rule id for a tunnel whose TLS SNI is missing or names another host.
26pub const RULE_SNI: &str = "proxy-sni";
27/// Rule id for a request the proxy could not parse or does not serve.
28pub const RULE_REQUEST: &str = "proxy-request";
29/// Rule id for a destination that could not be resolved or reached.
30pub const RULE_UPSTREAM: &str = "proxy-upstream";
31/// Rule id for a connection refused because it could not be recorded.
32pub const RULE_AUDIT: &str = "proxy-audit";
33
34/// Metadata services reachable by name on cloud instances.
35const METADATA_NAMES: &[&str] = &["metadata.google.internal", "metadata.goog"];
36const ALIBABA_METADATA: Ipv4Addr = Ipv4Addr::new(100, 100, 100, 200);
37/// Azure's `WireServer`, which serves instance configuration and keys to the VM.
38const AZURE_WIRESERVER: Ipv4Addr = Ipv4Addr::new(168, 63, 129, 16);
39const AWS_METADATA_V6: Ipv6Addr = Ipv6Addr::new(0xfd00, 0xec2, 0, 0, 0, 0, 0, 0x254);
40/// RFC 6052 well-known NAT64 prefix: `64:ff9b::a.b.c.d` reaches `a.b.c.d`.
41const NAT64: [u16; 6] = [0x64, 0xff9b, 0, 0, 0, 0];
42/// RFC 8215 local-use NAT64 prefix `64:ff9b:1::/48`. The operator picks how the
43/// IPv4 address is embedded inside it, so its addresses count as local network.
44const NAT64_LOCAL: [u16; 3] = [0x64, 0xff9b, 1];
45/// RFC 2765 IPv4-translated prefix: `::ffff:0:a.b.c.d` reaches `a.b.c.d`.
46const SIIT: [u16; 6] = [0, 0, 0, 0, 0xffff, 0];
47/// Ranges on the local network (or the carrier's), each with its description.
48const PRIVATE_V4: [(Ipv4Addr, u8, &str); 7] = [
49    (
50        Ipv4Addr::new(10, 0, 0, 0),
51        8,
52        "a private address (10.0.0.0/8)",
53    ),
54    (
55        Ipv4Addr::new(172, 16, 0, 0),
56        12,
57        "a private address (172.16.0.0/12)",
58    ),
59    (
60        Ipv4Addr::new(192, 168, 0, 0),
61        16,
62        "a private address (192.168.0.0/16)",
63    ),
64    (
65        Ipv4Addr::new(100, 64, 0, 0),
66        10,
67        "a shared CGNAT address (100.64.0.0/10)",
68    ),
69    (
70        Ipv4Addr::new(198, 18, 0, 0),
71        15,
72        "a benchmarking address (198.18.0.0/15)",
73    ),
74    (
75        Ipv4Addr::new(192, 0, 0, 0),
76        24,
77        "an IETF protocol address (192.0.0.0/24)",
78    ),
79    // Reserved for future use (RFC 1112 §4, RFC 6890): no public server has
80    // one, while some clouds hand it out inside a private network (GKE uses
81    // it for pod ranges). `255.255.255.255` is broadcast, refused before this.
82    (
83        Ipv4Addr::new(240, 0, 0, 0),
84        4,
85        "a reserved address (240.0.0.0/4)",
86    ),
87];
88
89/// Decide whether `host`, normalised as [`Request::host`](crate::Request::host)
90/// reports it, may be reached. Only an `allow` lets the connection proceed.
91/// The port is not looked at here: [`host_port`] decides both.
92#[must_use]
93pub fn host(policy: &CompiledPolicy<'_>, host: &str) -> Decision {
94    if let Some(refused) = metadata(host) {
95        return refused;
96    }
97    let atom = AtomicAction::Fetch {
98        host: host.to_owned(),
99    };
100    let mut decision = policy.evaluate_atomic(&atom).unwrap_or_else(|| {
101        Decision::single(
102            Verdict::Deny,
103            RULE_REQUEST,
104            format!("no rule decided {host}"),
105        )
106    });
107    // A deferred host (ADR-025) is refused too: the agent's permission flow never sees
108    // the proxy's connections.
109    if matches!(decision.verdict, Verdict::Review | Verdict::Defer) {
110        decision.verdict = Verdict::Deny;
111        decision
112            .reasons
113            .push("the proxy cannot prompt, so a host the hook would hold for review or leave to the agent is refused".to_owned());
114    }
115    decision
116}
117
118/// The refusal of a cloud metadata service's name, whatever the policy says.
119fn metadata(host: &str) -> Option<Decision> {
120    METADATA_NAMES
121        .iter()
122        .any(|m| host == *m || host.strip_suffix(m).is_some_and(|p| p.ends_with('.')))
123        .then(|| {
124            Decision::single(
125                Verdict::Deny,
126                RULE_ADDRESS,
127                format!("{host} is a cloud metadata service"),
128            )
129        })
130}
131
132/// The refusal for a request to `host:port` from a session with `taint`, if
133/// any (ADR-027). The core's taint rules decide (POLICY.md §4.1): after the
134/// session read secret material, network to every host but that secret's own
135/// needs review. The proxy cannot prompt, so that review is refused. Untrusted content alone
136/// changes nothing here: its taint protects writes.
137#[must_use]
138pub fn tainted(
139    policy: &CompiledPolicy<'_>,
140    host: &str,
141    port: u16,
142    taint: &Taint,
143) -> Option<Decision> {
144    let authority = if host.contains(':') {
145        format!("[{host}]:{port}")
146    } else {
147        format!("{host}:{port}")
148    };
149    let action = Action::Net {
150        url: format!("https://{authority}/"),
151    };
152    let mut decision = policy.with_taint(
153        Decision::new(Verdict::Allow),
154        &action,
155        &MapPathResolver::default(),
156        taint,
157    );
158    if decision.verdict == Verdict::Allow {
159        return None;
160    }
161    decision.verdict = Verdict::Deny;
162    decision.reasons.push(
163        "the proxy cannot prompt, so a session that read secret material reaches only that \
164         secret's own host until it ends; `openmoat allow` does not answer a secret's taint, \
165         so start a new session"
166            .to_owned(),
167    );
168    Some(decision)
169}
170
171/// Why the proxy never connects to `ip`, if it does not. Checked on every
172/// resolved address, so a name the policy allows cannot be pointed at a local
173/// or metadata service (DNS rebinding).
174#[must_use]
175pub fn forbidden(ip: IpAddr) -> Option<Forbidden> {
176    match ip.to_canonical() {
177        IpAddr::V4(v4) => forbidden_v4(v4),
178        IpAddr::V6(v6) => forbidden_v6(v6),
179    }
180}
181
182/// The classes of address the proxy refuses.
183#[derive(Debug, Clone, Copy, PartialEq, Eq)]
184#[non_exhaustive]
185pub enum Forbidden {
186    /// This machine (`127.0.0.0/8`, `::1`), including the proxy itself.
187    Loopback,
188    /// Link-local (`169.254.0.0/16`, `fe80::/10`): where cloud metadata lives.
189    LinkLocal,
190    /// A cloud metadata address outside the link-local ranges.
191    Metadata,
192    /// An address of this machine other than loopback (its LAN or public
193    /// address), where services listening on every interface answer. Found
194    /// only once connected ([`connect`](crate::connect)): the connection's
195    /// own end has the same address.
196    ThisMachine,
197    /// Unspecified, broadcast, multicast or `0.0.0.0/8`: never a server.
198    NotUnicast,
199    /// Private, CGNAT, benchmarking, reserved (`240.0.0.0/4`), unique-local
200    /// (`fc00::/7`) or deprecated site-local (`fec0::/10`): reachable
201    /// only when an allow rule names the address ([`named`]). Carries the
202    /// description naming the range.
203    Private(&'static str),
204}
205
206impl Forbidden {
207    /// A short phrase for reasons and the audit log.
208    #[must_use]
209    pub fn describe(self) -> &'static str {
210        match self {
211            Self::Loopback => "a loopback address",
212            Self::LinkLocal => "a link-local address",
213            Self::Metadata => "a cloud metadata address",
214            Self::ThisMachine => "an address of this machine",
215            Self::NotUnicast => "not a unicast address",
216            Self::Private(range) => range,
217        }
218    }
219}
220
221fn forbidden_v4(ip: Ipv4Addr) -> Option<Forbidden> {
222    if ip.is_loopback() {
223        Some(Forbidden::Loopback)
224    } else if ip.is_link_local() {
225        Some(Forbidden::LinkLocal)
226    } else if ip == ALIBABA_METADATA || ip == AZURE_WIRESERVER {
227        Some(Forbidden::Metadata)
228    } else if ip.is_unspecified() || ip.is_broadcast() || ip.is_multicast() || ip.octets()[0] == 0 {
229        Some(Forbidden::NotUnicast)
230    } else {
231        PRIVATE_V4
232            .iter()
233            .find(|(net, len, _)| u32::from(ip) >> (32 - len) == u32::from(*net) >> (32 - len))
234            .map(|(_, _, range)| Forbidden::Private(range))
235    }
236}
237
238fn forbidden_v6(ip: Ipv6Addr) -> Option<Forbidden> {
239    let seg = ip.segments();
240    if ip.is_loopback() {
241        Some(Forbidden::Loopback)
242    } else if ip.is_unspecified() || ip.is_multicast() {
243        Some(Forbidden::NotUnicast)
244    } else if seg[0] & 0xffc0 == 0xfe80 {
245        Some(Forbidden::LinkLocal)
246    } else if ip == AWS_METADATA_V6 {
247        Some(Forbidden::Metadata)
248    } else if let Some(v4) = carried_v4(ip) {
249        forbidden_v4(v4)
250    } else if let Some(why) = tunnelled_v4(ip).find_map(forbidden_v4) {
251        Some(why)
252    } else if seg[..3] == NAT64_LOCAL {
253        // The common /96 layout first, so a metadata or loopback address in it
254        // is named as such; any other layout is local network all the same.
255        let [a, b] = seg[6].to_be_bytes();
256        let [c, d] = seg[7].to_be_bytes();
257        forbidden_v4(Ipv4Addr::new(a, b, c, d)).or(Some(Forbidden::Private(
258            "a local-use NAT64 address (64:ff9b:1::/48)",
259        )))
260    } else if seg[0] & 0xfe00 == 0xfc00 {
261        Some(Forbidden::Private("a unique local address (fc00::/7)"))
262    } else if seg[0] & 0xffc0 == 0xfec0 {
263        // Deprecated (RFC 3879) but still routed inside networks that kept it:
264        // local network all the same, and never a public server.
265        Some(Forbidden::Private(
266            "a deprecated site-local address (fec0::/10)",
267        ))
268    } else {
269        None
270    }
271}
272
273/// The IPv4 address a well-known NAT64 (`64:ff9b::/96`), deprecated
274/// IPv4-compatible (`::/96`) or IPv4-translated (`::ffff:0:0/96`, which a
275/// stateless translator delivers, RFC 6145) address reaches.
276fn carried_v4(ip: Ipv6Addr) -> Option<Ipv4Addr> {
277    let seg = ip.segments();
278    (seg[..6] == NAT64 || seg[..6] == [0; 6] || seg[..6] == SIIT).then(|| {
279        let [a, b] = seg[6].to_be_bytes();
280        let [c, d] = seg[7].to_be_bytes();
281        Ipv4Addr::new(a, b, c, d)
282    })
283}
284
285/// The IPv4 addresses a 6to4 (`2002::/16`: the address in bits 16..48) or
286/// Teredo (`2001::/32`: the server in bits 32..64, the client inverted in the
287/// last 32 bits) address leads to: a relay or the server delivers it there.
288fn tunnelled_v4(ip: Ipv6Addr) -> impl Iterator<Item = Ipv4Addr> {
289    let o = ip.octets();
290    let six_to_four = (o[..2] == [0x20, 0x02]).then(|| Ipv4Addr::new(o[2], o[3], o[4], o[5]));
291    let teredo = o[..4] == [0x20, 0x01, 0, 0];
292    let client = teredo.then(|| Ipv4Addr::new(!o[12], !o[13], !o[14], !o[15]));
293    let server = teredo.then(|| Ipv4Addr::new(o[4], o[5], o[6], o[7]));
294    [six_to_four, client, server].into_iter().flatten()
295}
296
297/// The part of `policy` that decides a resolved address: its deny rules, and
298/// the allow rules' `net` and `fetch` patterns that name an address: a pattern
299/// starting with a digit or, without a port, containing `:` (a `host:port`
300/// pattern is judged by its host part, so `f*:5432` is a name), not starting
301/// with a glob metacharacter, and made only of what an address's text and a
302/// glob use.
303/// Anything else is left undecided (`review`), which neither opens a
304/// [`Forbidden::Private`] address ([`named`]) nor refuses one ([`denied`]), so
305/// a wildcard such as `*` or `*.example`, or a name such as
306/// `db.internal:5432`, never reaches the local network by DNS. Exclusions are
307/// all kept, and one without a port excludes the address on every port.
308#[must_use]
309pub fn address_policy(policy: &Policy) -> Policy {
310    let allow = policy
311        .allow
312        .iter()
313        .map(|g| {
314            // Every exclusion is kept: it can only narrow what the list names.
315            let keep = |list: &[String]| {
316                let kept: Vec<String> = list
317                    .iter()
318                    .filter(|p| p.starts_with('!') || names_address(p))
319                    .cloned()
320                    .collect();
321                ports::with_ports(&kept, false)
322            };
323            openmoat_core::RuleGroup {
324                id: g.id.clone(),
325                reason: g.reason.clone(),
326                net: keep(g.patterns(Kind::Net)),
327                fetch: keep(g.patterns(Kind::Fetch)),
328                ..Default::default()
329            }
330        })
331        .collect();
332    // Not `deny`: only a deny rule may refuse an address the host check passed.
333    Policy {
334        defaults: Defaults::All(Verdict::Review),
335        deny: policy.deny.clone(),
336        allow,
337        review: Vec::new(),
338        ..policy.clone()
339    }
340}
341
342/// Whether a host pattern names an address (see [`address_policy`]). A
343/// `host:port` pattern ([`port_pattern`](openmoat_core::port_pattern)) is
344/// judged by its host part, so a name made of hex letters with a port
345/// (`f*:5432`, `fac*:5432`) is a name, not an IPv6 glob reaching a unique
346/// local address: only a host part starting with a digit (`10.0.0.*:5432`)
347/// names an address with a port. Without a port, a `:` makes it IPv6 text
348/// (`fd12::*`, `fe80:*`).
349fn names_address(pattern: &str) -> bool {
350    let body = pattern.strip_prefix('!').unwrap_or(pattern);
351    let host = openmoat_core::port_pattern(body).map_or(body, |(host, _)| host);
352    !body.starts_with(['*', '?', '[', '{'])
353        && (host.starts_with(|c: char| c.is_ascii_digit()) || host.contains(':'))
354        && body
355            .chars()
356            .all(|c| c.is_ascii_hexdigit() || ".:*?[]{},-".contains(c))
357}
358
359/// Whether `addresses` (compiled from [`address_policy`]) allows `ip`, matched
360/// in its canonical text form (`::ffff:10.0.0.5` as `10.0.0.5`).
361#[must_use]
362pub fn named(addresses: &CompiledPolicy<'_>, ip: IpAddr) -> bool {
363    let atom = AtomicAction::Fetch {
364        host: ip.to_canonical().to_string(),
365    };
366    addresses
367        .evaluate_atomic(&atom)
368        .is_some_and(|d| d.verdict == Verdict::Allow)
369}
370
371/// Whether `addresses` allows `addr`'s address: [`named`], or, for IPv4, an
372/// allow rule that names it with this port (`10.0.0.5:5432`).
373#[must_use]
374pub fn named_on(addresses: &CompiledPolicy<'_>, addr: SocketAddr) -> bool {
375    if named(addresses, addr.ip()) {
376        return true;
377    }
378    let IpAddr::V4(v4) = addr.ip().to_canonical() else {
379        return false;
380    };
381    let atom = AtomicAction::Fetch {
382        host: format!("{v4}:{}", addr.port()),
383    };
384    addresses
385        .evaluate_atomic(&atom)
386        .is_some_and(|d| d.verdict == Verdict::Allow)
387}
388
389/// The deny rules of `addresses` (compiled from [`address_policy`]) that
390/// match `ip`, if any: a deny naming an address holds for every name that
391/// resolves to it. Matched in canonical text form, and for a NAT64,
392/// IPv4-compatible, IPv4-translated, 6to4 or Teredo address also as the IPv4 addresses it
393/// reaches. Allow rules never widen anything here; an address no deny rule
394/// matches gives `None`.
395#[must_use]
396pub fn denied(addresses: &CompiledPolicy<'_>, ip: IpAddr) -> Option<Decision> {
397    let ip = ip.to_canonical();
398    let carried: Vec<IpAddr> = match ip {
399        IpAddr::V6(v6) => carried_v4(v6)
400            .into_iter()
401            .chain(tunnelled_v4(v6))
402            .map(IpAddr::V4)
403            .collect(),
404        IpAddr::V4(_) => Vec::new(),
405    };
406    std::iter::once(ip).chain(carried).find_map(|ip| {
407        let atom = AtomicAction::Fetch {
408            host: ip.to_string(),
409        };
410        addresses
411            .evaluate_atomic(&atom)
412            .filter(|d| d.verdict == Verdict::Deny)
413    })
414}
415
416#[cfg(test)]
417mod tests;